#property indicator_chart_window
#property indicator_buffers 3
#property indicator_plots 3
#property indicator_color1 Red
#property indicator_color2 DarkGoldenrod
#property indicator_color3 BlueViolet
#property indicator_type1   DRAW_ARROW
#property indicator_type2   DRAW_ARROW
#property indicator_type3   DRAW_ARROW
#property indicator_width1 3
#property indicator_width2 2
#property indicator_width3 1

#define MODE_OPEN 0
#define MODE_CLOSE 3
#define MODE_VOLUME 4 
#define MODE_REAL_VOLUME 5
#define MODE_TRADES 0
#define MODE_HISTORY 1
#define SELECT_BY_POS 0
#define SELECT_BY_TICKET 1
//---
#define DOUBLE_VALUE 0
#define FLOAT_VALUE 1
#define LONG_VALUE INT_VALUE
//---
#define CHART_BAR 0
#define CHART_CANDLE 1
//---
#define MODE_ASCEND 0
#define MODE_DESCEND 1
//---
#define MODE_LOW 1
#define MODE_HIGH 2
#define MODE_TIME 5

#include <MovingAverages.mqh>

input int High_period = 70;
input int Low_period = 21;
input int Trigger_Sens = 2;
input bool ForecastHighTrendLine = true;
input bool StayLinesAfterDelete = false;
input string Note0 = "***** Semafor Drawing Adjustment";
input bool DrawHighPivotSemafor = true;
input bool DrawLowPivotSemafor = true;
input bool DrawLowestPivotSemafor = true;
input string Note1 = "***** High Trend Lines Adjustment";
input bool HTL_Draw = true;
input color HTL_ResColor = Red;
input color HTL_SupColor = Maroon;
input int HTL_Style = 1;
input int HTL_Width = 2;
input double HTL_Ext = 1.5;
input int HTL_InMemory = 10;
input int HTL_MinPivotDifferentIgnore = 5;
input string Note2 = "***** Low Trend Lines Adjustment";
input bool LTL_Draw = true;
input color LTL_ResColor = Gold;
input color LTL_SupColor = Goldenrod;
input int LTL_Style = 0;
input int LTL_Width = 0;
input double LTL_Ext = 1.5;
input int LTL_InMemory = 30;
input int LTL_MinPivotDifferentIgnore = 4;
input string Note3 = "***** High Semafor Adjustment";
input bool HighPivotTextAlarm = false;
input string HighPivotSoundAlarm = "alert.wav";
input int HighPivotSemaforDrawOffset = 28;
input int HighSemaforSymbol = 142;
input string Note4 = "***** High Semafor Adjustment";
input bool LowPivotTextAlarm = false;
input string LowPivotSoundAlarm = "";
input int LowPivotSemaforDrawOffset = 18;
input int LowSemaforSymbol = 141;
input string Note5 = "***** Lowest Semafor Adjustment";
input int LowestSemaforSymbol = 115;
input string Note6 = "***** Forecast Trend Line Adjustment";
input color FTL_Color = DeepPink;
input int FTL_Style = 1;
input int FTL_Width = 2;
input double FTL_Ext = 1.05;
double g_ibuf_300[];
double g_ibuf_304[];
double g_ibuf_308[];
string gs_durko_l1_312 = "Durko-L1";
string gs_durko_l2_320 = "Durko-L2";
int gi_340;
int gi_344;
int gi_348;
int gi_352;
datetime g_time_356 = 0;
int gi_364 = 0;
double gda_368[][6];
datetime gi_372 = 0;
datetime gi_376 = 0;
int gi_380 = -1;
int gi_384 = 0;
double gda_388[][6];
datetime gi_392 = 0;
datetime gi_396 = 0;
int gi_400 = -1;
int gi_404 = 0;
double gda_408[][6];
datetime gi_412 = 0;
datetime gi_416 = 0;
int gi_420 = -1;
int gi_424 = 0;
datetime gi_428 = 0;
datetime gi_432 = 0;
int gi_436 = -1;
string gsa_440[];
string gsa_444[];
color g_color_448;
color g_color_452;
int g_style_456;
int g_width_460;
double gd_464;
int gi_472 = 0;
string gs_476 = "";
int gi_484 = 0;
int gi_488 = 0;
string g_name_492 = "ForecastHighTrendLine_Durko";
bool gi_500 = false;
datetime g_datetime_504 = 0;
double g_price_508 = 0.0;
int gi_528 = 0;
int g_bars_532;
int x=1,y=0;
int SMAChMnr_IfZeroHan;
int MA_High_periodDEV7,MA_Low_periodDEV5,MA_2,MA_High_period,MA_Low_period,MA_5;
int unused=0;
double nowbar=0;

int OnInit() {
   g_bars_532 = Bars(_Symbol,_Period);
   gi_364 = false;
   TLMng_DeleteLinesCurrentTF();
   if(_Digits==3 || _Digits==5){x=10;y=-1;}
   SetIndexBuffer(0, g_ibuf_300,INDICATOR_DATA);
   SetIndexBuffer(1, g_ibuf_304,INDICATOR_DATA);
   SetIndexBuffer(2, g_ibuf_308,INDICATOR_DATA);
   ArraySetAsSeries(g_ibuf_300,true);ArraySetAsSeries(g_ibuf_304,true);ArraySetAsSeries(g_ibuf_308,true);
   PlotIndexSetInteger(0,PLOT_ARROW,HighSemaforSymbol);
   PlotIndexSetInteger(1,PLOT_ARROW,LowSemaforSymbol);
   PlotIndexSetInteger(2,PLOT_ARROW,LowestSemaforSymbol);
   PlotIndexSetDouble(0,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(1,PLOT_EMPTY_VALUE,0.0);
   PlotIndexSetDouble(2,PLOT_EMPTY_VALUE,0.0);
   IndicatorSetInteger(INDICATOR_DIGITS,_Digits);
   if (High_period == 0 && Low_period == 0) {
      Alert("High_period  Low_period  0. -      0");
      deinit();
      return (0);
   }
   gi_340 = High_period;
   gi_344 = Double2Int(MathRound(High_period / 7));
   gi_348 = Low_period;
   gi_352 = Double2Int(MathRound(Low_period / 5));
   if (Trigger_Sens <= 0) {
      //Trigger_Sens = 2;
      Alert("<Trigger_Sens> cannot have zero or less value.");
   }
   CheckLab();
   MA_High_periodDEV7=iMA(NULL,PERIOD_CURRENT,gi_344,0,MODE_SMA,PRICE_CLOSE);
   MA_Low_periodDEV5=iMA(NULL,PERIOD_CURRENT,gi_352,0,MODE_SMA,PRICE_CLOSE);
   MA_2=iMA(NULL,PERIOD_CURRENT,2,0,MODE_SMA,PRICE_CLOSE);
   MA_High_period=iMA(NULL,PERIOD_CURRENT,gi_340,0,MODE_LWMA,PRICE_WEIGHTED);
   MA_Low_period=iMA(NULL,PERIOD_CURRENT,gi_348,0,MODE_LWMA,PRICE_WEIGHTED);
   MA_5=iMA(NULL,PERIOD_CURRENT,5,0,MODE_LWMA,PRICE_WEIGHTED);
   return (0);
}

void OnChartEvent(const int id,         //    
                  const long& lparam,   //    long
                  const double& dparam, //    double
                  const string& sparam  //    string
  ){
int t=1;//---      
if(id==CHARTEVENT_KEYDOWN
)
t=1;
if(id==CHARTEVENT_OBJECT_CREATE
)
t=1;
if(id==CHARTEVENT_OBJECT_CHANGE
)
t=1;
if(id==CHARTEVENT_OBJECT_DELETE
)
t=1;
if(id==CHARTEVENT_CLICK
)
t=1;
if(id==CHARTEVENT_OBJECT_CLICK)
t=1;
if(id==CHARTEVENT_OBJECT_DRAG
)
t=1;
if(id==CHARTEVENT_OBJECT_ENDEDIT
)
t=1;
if(id==CHARTEVENT_CHART_CHANGE
)
t=1;
if(id==CHARTEVENT_CUSTOM
)
t=1;
if(id==CHARTEVENT_CUSTOM_LAST
)
t=1;


}
  



int OnCalculate (const int rates_total,      //   
                 const int prev_calculated,  //     
                 const datetime& time[],     // Time
                 const double& open[],       // Open
                 const double& high[],       // High
                 const double& low[],        // Low
                 const double& close[],      // Close
                 const long& tick_volume[],  // Tick Volume
                 const long& volume[],       // Real Volume
                 const int& spread[]         // Spread
   )
{
   if(BarsCalculated(MA_High_periodDEV7)<rates_total || BarsCalculated(MA_Low_periodDEV5)<rates_total || 
      BarsCalculated(MA_2)<rates_total || BarsCalculated(MA_High_period)<rates_total || 
      BarsCalculated(MA_Low_period)<rates_total || BarsCalculated(MA_5)<rates_total)
     {
      Alert("Not all data of iMA is calculated. Error",GetLastError());
      ResetLastError();
      return(0);
     }
   if (gi_364 == false) {
      if (g_bars_532 != Bars(_Symbol,_Period)) {
         deinit();
         Sleep(1000);
         g_bars_532 = Bars(_Symbol,_Period);
         g_time_356 = 0;
         return (0);
      }
   }
   MqlDateTime str1;
   if (gi_364 == false) {
      TimeToStruct(time[1],str1);
      gi_364 = true;
   }
 // if (g_time_356 == time[0])return (rates_total);
   g_time_356 = time[0];
   int l_ind_counted_0 = prev_calculated;
   int li_4 = Bars(_Symbol,_Period) - l_ind_counted_0;
   CheckLab();//return(rates_total);
   for (int li_8 = li_4; li_8 >= 1; li_8--) {nowbar=li_8;
      if(li_8==1542)
       li_4=li_4;
      /*g_ibuf_300[li_8]=0.0;
      g_ibuf_304[li_8]=0.0;
      g_ibuf_308[li_8]=0.0;*/
      //if(li_8<3253)continue;
      //if(li_8<3260 && li_8>3230)Alert(12," ",gi_372," ",nowbar);
      NewWave_Manager(li_8, gi_344, gi_340, gda_368, g_ibuf_300, gi_372, gi_376, gi_380, gi_384, DrawHighPivotSemafor, HighPivotSemaforDrawOffset, HighPivotTextAlarm, HighPivotSoundAlarm, 1);
      //if(li_8<3260 && li_8>3230)Alert(12," ",gi_372," ",nowbar);
      NewWave_Manager(li_8, gi_352, gi_348, gda_388, g_ibuf_304, gi_392, gi_396, gi_400, gi_404, DrawLowPivotSemafor, LowPivotSemaforDrawOffset, LowPivotTextAlarm, LowPivotSoundAlarm, 0);
      //if(li_8<3260 && li_8>3230)Alert(12," ",gi_372," ",nowbar);
      NewWave_Manager(li_8, 2, 5, gda_408, g_ibuf_308, gi_412, gi_416, gi_420, gi_424, DrawLowestPivotSemafor, 3, 0, "", 0);
      //if(li_8<3260 && li_8>3230)Alert(12," ",gi_372," ",nowbar);
     /* if (gi_384 && HTL_Draw) {
         TLMng_Init(HTL_ResColor, HTL_SupColor, HTL_Style, HTL_Width, HTL_Ext, HTL_InMemory, "HTL", HTL_MinPivotDifferentIgnore);
         TLMng_Main(gda_368, gsa_440, gi_384);
      }
      if (gi_404 && LTL_Draw) {
         TLMng_Init(LTL_ResColor, LTL_SupColor, LTL_Style, LTL_Width, LTL_Ext, LTL_InMemory, "LTL", LTL_MinPivotDifferentIgnore);
         TLMng_Main(gda_388, gsa_444, gi_404);
      }*/
   }
   //for ( int li_8 = li_4-1; li_8 >= 1; li_8--) Alert(li_8," ",g_ibuf_308[li_8]);
   return (rates_total);
}

void OnDeinit(const int reason){
int i=ObjectsTotal(0);
for(i=i;i>=0;i--)
 if(StringFind(ObjectName(0,i),"LTL_Asys_Auto")>-1)ObjectDelete(0,ObjectName(0,i));
 
 deinit();
}

void FTLMng_Main(int ai_0, datetime ai_4, double ad_8, int ai_16) {
   datetime l_time_28;
   if (ObjectFind(0,g_name_492) > -1) {
      ResetLastError();
      ObjectDelete(0,g_name_492);
      gi_500 = false;
      g_datetime_504 = false;
      g_price_508 = 0;
   }
   if(nowbar==1542)
   double tq=double(ai_4);
   double ld_20 = FTLMng_FindSecondpoint(ai_0, ai_4, ai_16);
   if (ld_20 != 0.0) {
      datetime Time[];
      ArraySetAsSeries(Time,true);
      CopyTime(_Symbol,_Period,0,ai_0+1,Time);
      l_time_28 = Time[ai_0];
      if (FTLMng_DrawFirst(ai_4, ad_8, l_time_28, ld_20) != 0) {
         gi_528 = ai_16;
         FTLMng_ReDraw(ai_0);
         gi_500 = true;
         return;
      }
   }
}

int FTLMng_DrawFirst(datetime a_datetime_0, double a_price_4, datetime a_datetime_12, double a_price_16) {
   if (ObjectCreate(0,g_name_492, OBJ_TREND, 0, a_datetime_0, a_price_4, a_datetime_12, a_price_16)) {
   //if(g_name_492=="LTL_Asys_AutoTL_1440_Res - 137")Alert(111);
      ObjectSetInteger(0,g_name_492,OBJPROP_RAY,false);
      ObjectSetInteger(0,g_name_492,OBJPROP_COLOR,FTL_Color);
      ObjectSetInteger(0,g_name_492,OBJPROP_STYLE,FTL_Style);
      ObjectSetInteger(0,g_name_492,OBJPROP_WIDTH,FTL_Width);
      g_datetime_504 = a_datetime_0;
      g_price_508 = a_price_4;
      ChartRedraw(0);
      return (1);
   }
   GetLastError();
   ResetLastError();
   return (0);
}

int FTLMng_ReDraw(int ai_0) {
   if (ObjectFind(0,g_name_492) == -1) {ResetLastError();return (0);}
   double ld_4 = FTLMng_FindSecondpoint(ai_0, g_datetime_504, gi_528);
   if (ld_4 == 0.0) return (0);
   datetime Time[];
   int count=ai_0;        //  
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,count,Time);
   datetime l_time_12 = Time[ai_0];
   datetime l_datetime_16 = 0;
   double ld_20 = 0;
   ObjectMove(0,g_name_492, 1, l_time_12, ld_4);
         
   if (FTL_Ext > 0.0) {
      TLMng_CountExt(FTL_Ext, g_datetime_504, g_price_508, l_time_12, ld_4, l_datetime_16, ld_20);
      if (l_datetime_16 == 0 || ld_20 == 0.0) return (0);
      ObjectMove(0,g_name_492, 1, l_datetime_16, ld_20);
         
   }
   ChartRedraw(0);
   return (0);
}

ENUM_TIMEFRAMES TFMigrate(int tf)
  {
   switch(tf)
     {
      case 0: return(PERIOD_CURRENT);
      case 1: return(PERIOD_M1);
      case 5: return(PERIOD_M5);
      case 15: return(PERIOD_M15);
      case 30: return(PERIOD_M30);
      case 60: return(PERIOD_H1);
      case 240: return(PERIOD_H4);
      case 1440: return(PERIOD_D1);
      case 10080: return(PERIOD_W1);
      case 43200: return(PERIOD_MN1);
      
      case 2: return(PERIOD_M2);
      case 3: return(PERIOD_M3);
      case 4: return(PERIOD_M4);      
      case 6: return(PERIOD_M6);
      case 10: return(PERIOD_M10);
      case 12: return(PERIOD_M12);
      case 16385: return(PERIOD_H1);
      case 16386: return(PERIOD_H2);
      case 16387: return(PERIOD_H3);
      case 16388: return(PERIOD_H4);
      case 16390: return(PERIOD_H6);
      case 16392: return(PERIOD_H8);
      case 16396: return(PERIOD_H12);
      case 16408: return(PERIOD_D1);
      case 32769: return(PERIOD_W1);
      case 49153: return(PERIOD_MN1);      
      default: return(PERIOD_CURRENT);
     }
  }

int TFMigrate2(int tf)
  {
   switch(tf)
     {
      case 2: return(2);
      case 3: return(3);
      case 4: return(4);      
      case 6: return(6);
      case 10: return(10);
      case 12: return(12);
      case 16385: return(60);
      case 16386: return(120);
      case 16387: return(180);
      case 16388: return(240);
      case 16390: return(360);
      case 16392: return(480);
      case 16396: return(720);
      case 16408: return(1440);
      case 32769: return(10080);
      case 49153: return(43200);      
      default: return(PERIOD_CURRENT);
     }
  }
  
int iBarShift(string symbol,
                  int tf,
                  datetime time,
                  bool exact=false)
  {
   if(time<0) return(-1);
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   datetime Arr[],time1;
   CopyTime(symbol,timeframe,0,1,Arr);
   time1=Arr[0];
   if(CopyTime(symbol,timeframe,time,time1,Arr)>0)
     {
      if(ArraySize(Arr)>2) return(ArraySize(Arr)-1);
      if(time<time1) return(1);
      else return(0);
     }
   else return(-1);
  }
  /*
void CalculateLWMA(int rates_total,int prev_calculated,int begin,const double &price[],double &buf[],int maperiod)
  {
   int        i,limit;
   int weightsum = maperiod *( maperiod + 1 ) / 2;
   double     sum;
//--- first calculation or number of bars was changed
   if(prev_calculated==0)
     {
      weightsum=0;
      limit=maperiod+begin;
      if(limit>ArrayRange(buf,0))limit=ArrayRange(buf,0);
      //--- set empty value for first limit bars
      for(i=0;i<limit;i++) buf[i]=0.0;
      //--- calculate first visible value
      double firstValue=0;
      for(i=begin;i<limit;i++)
        {
         int k=i-begin+1;
         weightsum+=k;
         firstValue+=k*price[i];
        }
      firstValue/=(double)weightsum;
      buf[limit-1]=firstValue;
     }
   else limit=prev_calculated-1;
      if(limit>ArrayRange(buf,0))limit=ArrayRange(buf,0);
//--- main loop
   for(i=limit;i<rates_total;i++)
     {
      sum=0;
      for(int j=0;j<maperiod;j++) sum+=(maperiod-j)*price[i-j];
      buf[i]=sum/weightsum;
     }
//---
  }
  */
double FTLMng_FindSecondpoint(int ai_0, datetime ai_4, int ai_8) {
   if (ai_0 == 0 || ai_4 == 0) return (0);
   int l_shift_12 = iBarShift(NULL, 0, ai_4, false);
   double l_ima_16 = 0;
   int per=int(1.1 * l_shift_12);
   if(ai_8 == 1) 
    {double High[];
     ArraySetAsSeries(High,true);
     CopyHigh(_Symbol,_Period,0,Bars(_Symbol,_Period),High);
     //CalculateLWMA(per*2+2,0,0,High,mabufhigh,per);
     l_ima_16 = LinearWeightedMA(ai_0,per,High); //mabufhigh[ai_0];
    }
   if(ai_8 == 2)
    {double Low[];
     ArraySetAsSeries(Low,true);
     CopyHigh(_Symbol,_Period,0,Bars(_Symbol,_Period),Low);
     //CalculateLWMA(per*2+2,0,0,Low,mabuflow, per);
     l_ima_16 = LinearWeightedMA(ai_0,per,Low);//mabuflow[ai_0];
    }
   return (l_ima_16);
}

int TLMng_Main( double& ada_0[][6],  string& asa_4[], int &ai_8) {
   int li_16=0;
   int li_20;
   double ld_24;
   double ld_32;
   int li_40;
   int li_44;
   int l_shift_48;
   int l_shift_52;
   int li_12 = WAMng_WaveCount(ada_0);
   if (li_12 > 0) li_16 = WAMng_WaveType(ada_0, li_12);
   if (li_16 > 0) {
      li_20 = WAMng_LookPrivWaveSameType(ada_0, li_16, li_12);
      if (li_20 > 0) {
         ld_24 = WAMng_GetWavePiv(ada_0, li_12);
         ld_32 = WAMng_GetWavePiv(ada_0, li_20);
         if (ld_24 == 0.0 || ld_32 == 0.0) return (0);
         li_40 = WAMng_GetWavePivBar(ada_0, li_12);
         li_44 = WAMng_GetWavePivBar(ada_0, li_20);
         if (li_40 == 0 || li_44 == 0) return (0);
         if (gi_488 > 0) {
            l_shift_48 = iBarShift(NULL, 0, li_40, false);
            l_shift_52 = iBarShift(NULL, 0, li_44, false);
            if (l_shift_52 - l_shift_48 <= gi_488) return (0);
         }
         if (li_16 == 1) {
            if (ld_24 < ld_32) TLMng_BuidLine(asa_4, li_16, ld_32, li_44, ld_24, li_40);
            else ai_8 = 0;
         } else {
            if (li_16 == 2) {
               if (ld_24 > ld_32) TLMng_BuidLine(asa_4, li_16, ld_32, li_44, ld_24, li_40);
               else ai_8 = 0;
            }
         }
      }
   }
   return (0);
}

void TLMng_Init(color ai_0, color ai_4, int ai_8, int ai_12, double ad_16, int ai_24, string as_28, int ai_36) {
   g_color_448 = ai_0;
   g_color_452 = ai_4;
   if (g_width_460 <= 1) {
      g_style_456 = ai_8;
      g_width_460 = 1;
   } else {
      g_style_456 = 0;
      g_width_460 = ai_12;
   }
   if (ad_16 < 1.0) gd_464 = 1;
   else gd_464 = ad_16;
   gi_472 = ai_24;
   gs_476 = as_28;
   gi_488 = ai_36;
}

void TLMng_BuidLine( string& asa_0[], int ai_4, double ad_8, int a_datetime_16, double ad_20, int a_datetime_28) {
   string ls_48;
   datetime l_datetime_56;
   double ld_60;
   int l_count_68;
   double ld_72;
   string ls_32 = "";
   if (gs_476 == "") ls_32 = "Def";
   else ls_32 = gs_476;
   string l_name_40 = ls_32 + "_Asys_AutoTL_" + DoubleToString(TFMigrate2(Period()),0) + "_";
   gi_484++;
   if (ai_4 == 2) ls_48 = "Sup";
   else ls_48 = "Res";
   l_name_40 = l_name_40 + ls_48 + " - " +IntegerToString(gi_484);
   if (ObjectCreate(0,l_name_40, OBJ_TREND, 0, a_datetime_16, NormalizeDouble(ad_8, _Digits+y), a_datetime_28, NormalizeDouble(ad_20, _Digits+y))) {
   
      ObjectSetInteger(0,l_name_40,OBJPROP_RAY_RIGHT,false);
      if (ls_48 == "Sup") ObjectSetInteger(0,l_name_40,OBJPROP_COLOR,g_color_452);
      else {
         if (ls_48 == "Res") ObjectSetInteger(0,l_name_40,OBJPROP_COLOR,g_color_448);
         else ObjectSetInteger(0,l_name_40,OBJPROP_COLOR,Red);
      }
      ObjectSetInteger(0,l_name_40,OBJPROP_STYLE,g_style_456);
      ObjectSetInteger(0,l_name_40,OBJPROP_WIDTH,g_width_460);
      if (gd_464 > 1.0) {
         l_datetime_56 = 0;
         ld_60 = 0;
         TLMng_CountExt(gd_464, a_datetime_16, NormalizeDouble(ad_8, _Digits+y), a_datetime_28, NormalizeDouble(ad_20, _Digits+y), l_datetime_56, ld_60);
         ObjectMove(0,l_name_40, 1, l_datetime_56, ld_60);
         
         l_count_68 = 0;
         ld_72 = TLMng_CorrectLine(l_name_40, a_datetime_28, NormalizeDouble(ad_20, _Digits+y));
         while (ld_72 != 0.0) {
            ld_60 += ld_72;
            ObjectMove(0,l_name_40, 1, l_datetime_56, ld_60);
         
            ld_72 = TLMng_CorrectLine(l_name_40, a_datetime_28, NormalizeDouble(ad_20, _Digits+y));
            l_count_68++;
            if (l_count_68 > 20) break;
         }
      }
      TLMng_CheckNumTL(asa_0, l_name_40, gi_472);
      CheckLab();
      ChartRedraw(0);
   }
}

double ObjectGetValueByShift(string name,int shift){
ENUM_TIMEFRAMES timeframe=TFMigrate(PERIOD_CURRENT);
MqlRates mql4[];
CopyRates(NULL,timeframe,shift,1,mql4);
return(ObjectGetValueByTime(0,name,mql4[0].time,0));
}

double TLMng_CorrectLine(string a_name_0, int ai_8, double ad_12) {
   if (a_name_0 == "" || ai_8 == 0) return (0);
   GetLastError();ResetLastError();
   double ld_20 = ObjectGetValueByShift(a_name_0, iBarShift(NULL, 0, ai_8, true));
   if (GetLastError() > 0/* NO_ERROR */) {ResetLastError();return (0);}
   double ld_28 = ld_20 - ad_12;
   if (IsInChanel(ld_28, 0, 2.0 * _Point * x) == 1) return (0);
   return (-1.0 * ld_28);
}

void TLMng_CheckNumTL(string &asa_0[], string as_4, int ai_12) {
   if (as_4 == "" || ai_12 < 0) return;
   if (ArraySize(asa_0) + 1 > ai_12) {
      if (!ObjectDelete(0,asa_0[0])) {Print("   - ", asa_0[0], "   - ", GetLastError());ResetLastError();}
      ArrayCopy(asa_0, asa_0, 0, 1);
      asa_0[ArraySize(asa_0) - 1] = as_4;
      return;
   }
   ArrayResize(asa_0, ArraySize(asa_0) + 1);
   asa_0[ArraySize(asa_0) - 1] = as_4;
}

void TLMng_DeleteAllLines() {
   int li_0 = ArrayRange(gsa_440, 0);
   if (li_0 > 0) {
      for (int l_index_4 = 0; l_index_4 <= li_0 - 1; l_index_4++)
         if (ObjectFind(0,gsa_440[l_index_4]) > -1) ObjectDelete(0,gsa_440[l_index_4]);else ResetLastError();
   }
   ArrayResize(gsa_440, 0);
   li_0 = 0;
   li_0 = ArrayRange(gsa_444, 0);
   if (li_0 > 0) {
      for (int l_index_4 = 0; l_index_4 <= li_0 - 1; l_index_4++)
         if (ObjectFind(0,gsa_444[l_index_4]) > -1) ObjectDelete(0,gsa_444[l_index_4]); else ResetLastError();
   }
   ArrayResize(gsa_444, 0);
}

void TLMng_DeleteLinesCurrentTF() {
   string l_name_4;
   string lsa_12[];
   int l_objs_total_0 = ObjectsTotal(0);
   if (l_objs_total_0 != 0) {
      for (int li_16 = 0; li_16 <= l_objs_total_0 - 1; li_16++) {
         l_name_4 = ObjectName(0,li_16);
         string newstr="";
         StringConcatenate(newstr,"Asys_AutoTL_", TFMigrate2(Period()));
         if (StringFind(l_name_4, newstr) > -1) {
            ArrayResize(lsa_12, ArraySize(lsa_12) + 1);
            lsa_12[ArraySize(lsa_12) - 1] = l_name_4;
         }
      }
      if (ArraySize(lsa_12) > 0) {
         for (int li_16 = 0; li_16 <= ArraySize(lsa_12) - 1; li_16++)
            if (ObjectFind(0,lsa_12[li_16]) > -1) ObjectDelete(0,lsa_12[li_16]); else ResetLastError();
      }
   }
}

void TLMng_DeleteLinesCurrentInd() {
   string l_name_4;
   string lsa_12[];
   int l_objs_total_0 = ObjectsTotal(0);
   if (l_objs_total_0 != 0) {
      for (int li_16 = 0; li_16 <= l_objs_total_0 - 1; li_16++) {
         l_name_4 = ObjectName(0,li_16);
         if (StringFind(l_name_4, "Asys_AutoTL") > -1) {
            ArrayResize(lsa_12, ArraySize(lsa_12) + 1);
            lsa_12[ArraySize(lsa_12) - 1] = l_name_4;
         }
      }
      if (ArraySize(lsa_12) > 0) {
         for (int li_16 = 0; li_16 <= ArraySize(lsa_12) - 1; li_16++)
            if (ObjectFind(0,lsa_12[li_16]) > -1) ObjectDelete(0,lsa_12[li_16]);else ResetLastError();
      }
   }
}

void TLMng_CountExt(double ad_0, datetime ai_8, double ad_12, datetime ai_20, double ad_24, datetime &ai_32, double &ad_36) {
   int l_shift_44 = iBarShift(NULL, 0, ai_8, false);
   int l_shift_48 = iBarShift(NULL, 0, ai_20, false);
   int li_52 = l_shift_44 - l_shift_48;
   int li_56 = Double2Int(MathRound(li_52 * ad_0));
   double ld_60 = MathAbs(ad_24 - ad_12);
   if (li_56 == 0) ad_36 = ad_24;
   else {
      if (ad_24 > ad_12) ad_36 = NormalizeDouble(ad_24 + li_56 * ld_60 / li_52, _Digits+y);
      if (ad_24 < ad_12) ad_36 = NormalizeDouble(ad_24 - li_56 * ld_60 / li_52, _Digits+y);
    }
   datetime Time[];
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,l_shift_48+1,Time);
   ai_32 = Time[l_shift_48] + 60 * TFMigrate2(Period()) * li_56;
   //if(unused==0){unused=1;Alert(li_56," ",l_shift_48," ",TFMigrate2(Period())," ",double(ai_32));}
}

int WAMng_LookPrivWaveSameType(double& ada_0[][6], int ai_4, int ai_8) {
   int li_20;
   if (ai_4 <= 0 || ai_8 == 0) return (0);
   int li_ret_12 = ai_8 - 1;
   bool li_16 = false;
   while (li_16 == false) {
      li_20 = WAMng_WaveType(ada_0, li_ret_12);
      if (li_20 > 0) {
         if (li_20 == ai_4) {
            li_16 = true;
            break;
         }
      }
      li_ret_12--;
      if (li_ret_12 < 0) li_16 = true;
   }
   if (li_ret_12 > 0) return (li_ret_12);
   return (0);
}

int WAMng_WaveType( double& ada_0[][6], int ai_4) {
   int li_8 = WAMng_WaveCount(ada_0);
   if (ai_4 < 1 || ai_4 > li_8) return (-1);
   return (int(ada_0[ai_4 - 1][0]));
}

int WAMng_WaveCount( double& ada_0[][6]) {
   return (ArrayRange(ada_0, 0));
}

double WAMng_GetWavePiv(double& ada_0[][6], int ai_4) {
   int li_8 = WAMng_WaveCount(ada_0);
   if (ai_4 < 1 || ai_4 > li_8) return (0);
   return (ada_0[ai_4 - 1][3]);
}

int WAMng_GetWavePivBar( double& ada_0[][6], int ai_4) {
   int li_8 = WAMng_WaveCount(ada_0);
   if (ai_4 < 1 || ai_4 > li_8) return (0);
   return (int(ada_0[ai_4 - 1][5]));
}

int NewWave_Manager(int ai_0, int ai_4, int ai_8, double &ada_12[][6], double &ada_16[], datetime &ai_20, datetime &ai_24, int &ai_28, int &ai_32, bool ai_36, int ai_40, int ai_44, string as_48, int ai_56) {
   int l_str2int_92;
   int l_shift_96;
   int l_shift_100;/*
   double ada_12[][6];
   bool resize=false;
   int size = ArrayRange(mymas,0);if(size==0){size=1;resize=true;}
   ArrayResize(ada_12, size);ArrayResize(mymas, size);
   int qw=ArrayCopy(mymas,ada_12);
   if(resize){ArrayResize(ada_12, 0);ArrayResize(mymas, 0);}
   /*if(unused==0)
    {unused=ai_0;
     for(int yw=0;yw<ArrayRange(ada_12,0);yw++)
      for(int yq=0;yq<6;yq++)
      Alert(yw," ",yq," ",ada_12[yw][yq]," ",mymas[yw][yq]);
    }*/
   if(ai_0==3255 && ai_8==5)
    ai_0=ai_0;
   if(ai_8==gi_340)
    gi_340=gi_340;
   Init_Wave_Manager(ai_20, ai_24, ai_28);
   if (gi_428 == 0) {
      F_F_Zero(ai_4, ai_8, ai_0);
      ai_32 = 0;
      DeInit_Wave_Manager(ai_20, ai_24, ai_28);
      return (0);
   }
   //if(unused==0){unused=ai_0;Alert(unused);}
   // if(unused==1)return(0);
  // if(ai_0<594)return(0);
   if (ai_56 == 1 && ForecastHighTrendLine == true && gi_500 == true) FTLMng_ReDraw(ai_0);
   if (gi_432 == 0) {
      F_S_Zero(ai_4, ai_8, gi_436, ai_0);
      if (gi_432 == 0) {
         ai_32 = 0;
         DeInit_Wave_Manager(ai_20, ai_24, ai_28);
         return (0);
      }
   }
   
   Add_Wave(gi_428, gi_432, gi_436, ada_12,ai_0,ai_8);
   ai_32 = 1;
   int l_str2int_60 = StringToInteger(DoubleToString(ada_12[ArrayRange(ada_12, 0) - 1][4], 0));
   datetime Time[];
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,l_str2int_60+1,Time);
   datetime l_time_88 = Time[l_str2int_60];
   if (ai_36) {
      l_str2int_92 = l_str2int_60;
      l_shift_96 = iBarShift(NULL, 0, gi_432, false);
      l_shift_100 = iBarShift(NULL, 0, gi_428, false);
      for (int li_104 = l_shift_96 - 1; li_104 > l_str2int_92; li_104++) ada_16[li_104] = 0.0;
      ada_16[l_str2int_60] = ada_12[ArrayRange(ada_12, 0) - 1][3];
      //if(l_str2int_60==632)Alert(1);
      //ada_16[632]=ada_16[632];
      //Alert(gi_436);
      if (gi_436 == 1) ada_16[l_str2int_60] += ai_40 * _Point * x;
      else
         if (gi_436 == 2) 
         ada_16[l_str2int_60] = ada_16[l_str2int_60] - ai_40 * _Point * x;
      if (ai_0 < 50) 
       {
        CopyTime(_Symbol,_Period,0,0+1,Time);
        if (as_48 != "") PlaySound(as_48);
        if (ai_44 == 1) Alert(PrepareTextAlarm(Time[0], gi_436, ada_12[ArrayRange(ada_12, 0) - 1][3], l_time_88));
      }
   }
   if (ai_56 == 1 && ForecastHighTrendLine == true) 
    {   FTLMng_Main(ai_0, l_time_88, ada_12[ArrayRange(ada_12, 0) - 1][3], gi_436);
    }
   gi_428 = gi_432;
   if (gi_436 == 1) gi_436 = 2;
   else {
      if (gi_436 == 2) gi_436 = 1;
      else gi_436 = -1;
   }
   gi_432 = 0;
   DeInit_Wave_Manager(ai_20, ai_24, ai_28);
   return (0);
}

void Init_Wave_Manager(datetime ai_0, datetime ai_4, int ai_8) {
   gi_428 = ai_0;
   gi_432 = ai_4;
   gi_436 = ai_8;
}

void DeInit_Wave_Manager(datetime &ai_0, datetime &ai_4, int &ai_8) {
   ai_0 = gi_428;
   ai_4 = gi_432;
   ai_8 = gi_436;
}

void F_F_Zero(int ai_0, int ai_4, int ai_8) {
   int li_12;
   datetime ld_16;
   int li_24;
   if (Bars(_Symbol,_Period) - ai_8 >= ai_4 * 2) {
      li_12 = ChMnr_CurrentWaveType(ai_0, ai_4, ai_8);
      ld_16 = 0;
      li_24 = ai_8;
      gi_428 = 0;
      gi_436 = 0;
      if (li_12 > 0) {
         ld_16 = ChMnr_FindZeroFromShift(ai_0, ai_4, li_24);
         if (ld_16 <= 0.0) return;
      } else {
         li_12 = ChMnr_FirstWaveFromShift(ai_0, ai_4, li_24);
         if (li_12 <= 0) return;
         ld_16 = ChMnr_FindZeroFromShift(ai_0, ai_4, li_24);
         if (ld_16 <= 0.0) return;
      }
   datetime Time[];
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,li_24+1,Time);
   
      double trulya=double(li_24);
      gi_428 = Time[li_24];
      gi_436 = li_12;
   }
}

void F_S_Zero(int ai_0, int ai_4, int ai_8, int ai_12) {
   int li_16 = ChMnr_CurrentWaveType(ai_0, ai_4, ai_12);
   if (gi_428 == 0 || gi_436 <= 0 || ai_8 <= 0) return;
   if (li_16 == 0) {
      gi_432 = 0;
      return;
   }
   if (li_16 == ai_8) {
      gi_432 = 0;
      return;
   }
   datetime Time[];
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,ai_12+1,Time);
   if (li_16 != ai_8) gi_432 = Time[ai_12];
}

datetime ChMnr_FindZeroFromShift(int ai_0, int ai_4, int &ai_8) {
   int l_count_12 = 0;
   datetime l_time_16 = -99999;
   bool li_24 = false;
   while (li_24 == false) {
      if (ChMnr_IfZero(ai_0, ai_4, ai_8 + l_count_12) == 1) {
         li_24 = true;
   datetime Time[];
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,ai_8 + l_count_12+1,Time);
         l_time_16 = Time[ai_8 + l_count_12];
         ai_8 += l_count_12;
      }
      l_count_12++;
      if (ai_8 + l_count_12 >= Bars(_Symbol,_Period)) {
         li_24 = true;
         l_time_16 = -55555;
      }
   }
   return (l_time_16);
}

int ChMnr_FirstWaveFromShift(int ai_0, int ai_4, int &ai_8) {
   int l_count_12 = 0;
   int li_ret_16 = -99999;
   int li_20 = 0;
   bool li_24 = false;
   while (li_24 == false) {
      li_20 = ChMnr_CurrentWaveType(ai_0, ai_4, ai_8 + l_count_12);
      if (li_20 > 0) {
         li_ret_16 = li_20;
         li_24 = true;
         ai_8 += l_count_12;
      }
      l_count_12++;
      if (ai_8 + l_count_12 >= Bars(_Symbol,_Period)) {
         li_24 = true;
         li_ret_16 = -55555;
      }
   }
   return (li_ret_16);
}

int ChMnr_IfZero(int a_period_0, int a_period_4, int ai_8) {
   int ma_handle1=-1,ma_handle2=-1;
   if(a_period_0==gi_344)ma_handle1=MA_High_periodDEV7;
   if(a_period_0==gi_352)ma_handle1=MA_Low_periodDEV5;
   if(a_period_0==2)ma_handle1=MA_2;
   if(a_period_4==gi_340)ma_handle2=MA_High_period;
   if(a_period_4==gi_348)ma_handle2=MA_Low_period;
   if(a_period_4==5)ma_handle2=MA_5;
   //if(BarsCalculated(ma_handle1)<rates_total) return(0);
   double ma1[1],ma2[1];
   CopyBuffer(ma_handle1,0,ai_8,1,ma1);
   CopyBuffer(ma_handle2,0,ai_8,1,ma2);
   double ld_12 = NormalizeToDigit(ma1[0]);
   double ld_20 = NormalizeToDigit(ma2[0]);
   double ld_28 = ld_12 - ld_20;
   return (IsInChanel(ld_28, 0, Trigger_Sens));
}

int ChMnr_CurrentWaveType(int a_period_0, int a_period_4, int ai_8) {
   int ma_handle1=-1,ma_handle2=-1;
   if(a_period_0==gi_344)ma_handle1=MA_High_periodDEV7;
   if(a_period_0==gi_352)ma_handle1=MA_Low_periodDEV5;
   if(a_period_0==2)ma_handle1=MA_2;
   if(a_period_4==gi_340)ma_handle2=MA_High_period;
   if(a_period_4==gi_348)ma_handle2=MA_Low_period;
   if(a_period_4==5)ma_handle2=MA_5;
   //if(BarsCalculated(ma_handle1)<rates_total) return(0);
   double ma1[1],ma2[1];
   CopyBuffer(ma_handle1,0,ai_8,1,ma1);
   CopyBuffer(ma_handle2,0,ai_8,1,ma2);
   double l_ima_12 = ma1[0];
   double l_ima_20 = ma2[0];
   double ld_28 = l_ima_12 - l_ima_20;
   if (ChMnr_IfZero(a_period_0, a_period_4, ai_8) == 1) return (0);
   if (ld_28 > 0.0) return (1);
   if (ld_28 < 0.0) return (2);
   return (-1);
}

int Add_Wave(datetime ai_0, datetime ai_4, int ai_8, double &ada_12[][6],int hlam1,int hlam2) {
   int li_16 = ArrayRange(ada_12, 0);
   //if(li_16>0)Alert(hlam1," ",ada_12[li_16 - 1][0]," ",ada_12[li_16 - 1][1]," ",ada_12[li_16 - 1][2]," ",ada_12[li_16 - 1][3]," ",ada_12[li_16 - 1][4]," ",ada_12[li_16 - 1][5]);
   li_16++;
   ArrayResize(ada_12, li_16);
   //Alert(ada_12[li_16 - 1][0]," ",ada_12[li_16 - 1][1]," ",ada_12[li_16 - 1][2]," ",ada_12[li_16 - 1][3]," ",ada_12[li_16 - 1][4]," ",ada_12[li_16 - 1][5]);
   ada_12[li_16 - 1][0] = ai_8;
   ada_12[li_16 - 1][1] = ai_0;
   ada_12[li_16 - 1][2] = ai_4;
   double li_20 = 0;
   if (li_16 - 2 >= 0) li_20 = ada_12[li_16 - 2][5];
     // if(hlam1==594 && hlam2==5)Alert((ada_12[li_16 - 2][5])," ", double(ai_4)," ", double(ai_8)," ", double(li_20));
   datetime li_24 = FindPivot(ai_0, ai_4, ai_8, li_20);
   if (li_24 != 0) {
      ada_12[li_16 - 1][4] = iBarShift(NULL, 0, li_24, false);
      ada_12[li_16 - 1][5] = li_24;
      double High[];
      ArraySetAsSeries(High,true);
      int count;
      count=iBarShift(NULL, 0, li_24, false);
      CopyHigh(_Symbol,_Period,0,count+1,High);
      if (ai_8 == 1) ada_12[li_16 - 1][3] = High[count];
      else
       {double Low[];
        ArraySetAsSeries(Low,true);
        count=0;
        count=iBarShift(NULL, 0, li_24, false);
        CopyLow(_Symbol,_Period,0,count+1,Low);
        if (ai_8 == 2) ada_12[li_16 - 1][3] = Low[count];
       }
   }
   return (0);
}

int iHighest(string symbol,
                 int tf,
                 int type,
                 int count=WHOLE_ARRAY,
                 int start=0)
  {
   if(start<0) return(-1);
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   if(count<=0) count=Bars(symbol,timeframe);
   if(type<=MODE_OPEN)
     {
      double Open[];
      ArraySetAsSeries(Open,true);
      CopyOpen(symbol,timeframe,start,count,Open);
      return(ArrayMaximum(Open,0,count)+start);
     }
   if(type==MODE_LOW)
     {
      double Low[];
      ArraySetAsSeries(Low,true);
      CopyLow(symbol,timeframe,start,count,Low);
      return(ArrayMaximum(Low,0,count)+start);
     }
   if(type==MODE_HIGH)
     {
      double High[];
      ArraySetAsSeries(High,true);
      CopyHigh(symbol,timeframe,start,count,High);
      return(ArrayMaximum(High,0,count)+start);
     }
   if(type==MODE_CLOSE)
     {
      double Close[];
      ArraySetAsSeries(Close,true);
      CopyClose(symbol,timeframe,start,count,Close);
      return(ArrayMaximum(Close,0,count)+start);
     }
   if(type==MODE_VOLUME)
     {
      long Volume[];
      ArraySetAsSeries(Volume,true);
      CopyTickVolume(symbol,timeframe,start,count,Volume);
      return(ArrayMaximum(Volume,0,count)+start);
     }
   if(type>=MODE_TIME)
     {
      datetime Time[];
      ArraySetAsSeries(Time,true);
      CopyTime(symbol,timeframe,start,count,Time);
      return(ArrayMaximum(Time,0,count)+start);
      //---
     }
   return(0);
  }
  
int iLowest(string symbol,
                int tf,
                int type,
                int count=WHOLE_ARRAY,
                int start=0)
  {
   if(start<0) return(-1);
   ENUM_TIMEFRAMES timeframe=TFMigrate(tf);
   if(count<=0) count=Bars(symbol,timeframe);
   if(type<=MODE_OPEN)
     {
      double Open[];
      ArraySetAsSeries(Open,true);
      CopyOpen(symbol,timeframe,start,count,Open);
      return(ArrayMinimum(Open,0,count)+start);
     }
   if(type==MODE_LOW)
     {
      double Low[];
      ArraySetAsSeries(Low,true);
      CopyLow(symbol,timeframe,start,count,Low);
      return(ArrayMinimum(Low,0,count)+start);
     }
   if(type==MODE_HIGH)
     {
      double High[];
      ArraySetAsSeries(High,true);
      CopyHigh(symbol,timeframe,start,count,High);
      return(ArrayMinimum(High,0,count)+start);
     }
   if(type==MODE_CLOSE)
     {
      double Close[];
      ArraySetAsSeries(Close,true);
      CopyClose(symbol,timeframe,start,count,Close);
      return(ArrayMinimum(Close,0,count)+start);
     }
   if(type==MODE_VOLUME)
     {
      long Volume[];
      ArraySetAsSeries(Volume,true);
      CopyTickVolume(symbol,timeframe,start,count,Volume);
      return(ArrayMinimum(Volume,0,count)+start);
     }
   if(type>=MODE_TIME)
     {
      datetime Time[];
      ArraySetAsSeries(Time,true);
      CopyTime(symbol,timeframe,start,count,Time);
      return(ArrayMinimum(Time,0,count)+start);
     }
//---
   return(0);
  }

datetime FindPivot(datetime ai_0, datetime ai_4, int ai_8, int ai_12) {
   int l_highest_32;
   int l_lowest_36;
   if (ai_8 < 1 || ai_0 == 0 || ai_4 == 0) return (0);
   int l_shift_16 = iBarShift(NULL, 0, ai_0, true);
   int l_shift_20 = iBarShift(NULL, 0, ai_4, true);
   int l_shift_24 = 0;
   if (ai_12 > 0) l_shift_24 = iBarShift(NULL, 0, ai_12, true);
   if (l_shift_16 == -1 || l_shift_20 == -1) return (0);
   int li_28 = 0;
   if (l_shift_24 > 0) li_28 = l_shift_24 - l_shift_20 + 1;
   else li_28 = l_shift_16 - l_shift_20 + 1;
   if (ai_8 == 1) {
      l_highest_32 = iHighest(NULL, 0, MODE_HIGH, li_28, l_shift_20);
   datetime Time[];
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,l_highest_32+1,Time);
      return (Time[l_highest_32]);
   }
   if (ai_8 == 2) {
      l_lowest_36 = iLowest(NULL, 0, MODE_LOW, li_28, l_shift_20);
   datetime Time[];
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,l_lowest_36+1,Time);
      return (Time[l_lowest_36]);
   }
   return (0);
}

int deinit() {
   if (StayLinesAfterDelete == false) TLMng_DeleteAllLines();
   ObjectDelete(0,g_name_492);
   ArrayResize(gsa_440, 0.0);
   ArrayResize(gsa_444, 0.0);
   ArrayResize(gda_368, 0.0);
   ArrayResize(gda_388, 0.0);
   ArrayResize(gda_408, 0.0);
   ArrayInitialize(g_ibuf_300, 0.0);
   ArrayInitialize(g_ibuf_304, 0.0);
   ArrayInitialize(g_ibuf_308, 0.0);
   ObjectDelete(0,gs_durko_l1_312);
   ObjectDelete(0,gs_durko_l2_320);
   if (StayLinesAfterDelete == false) TLMng_DeleteLinesCurrentInd();
   return (0);
}

int Double2Int(double ad_0) {
   return (int(StringToInteger(DoubleToString(ad_0, 0))));
}

int IsInChanel(double ad_0, double ad_8, double ad_16) {
   double ld_24 = ad_8 + ad_16;
   double ld_32 = ad_8 - ad_16;
   if (ad_0 <= ld_24 && ad_0 >= ld_32) return (1);
   return (0);
}

double NormalizeToDigit(double ad_0) {
   double ld_ret_8 = ad_0;
   for (int li_16 = 1; li_16 <= _Digits+y; li_16++) ld_ret_8 = 10.0 * ld_ret_8;
   return (ld_ret_8);
}

string PrepareTextAlarm(datetime ai_0, int ai_4, double ad_8, datetime ai_16) {
   string ls_ret_20 = "";
   ls_ret_20 = ls_ret_20 + TimeToString(ai_0, TIME_DATE) + " " + TimeToString(ai_0, TIME_MINUTES) + " : ";
   if (ai_4 == 1) ls_ret_20 = ls_ret_20 + "The top maximum is generated : ";
   if (ai_4 == 2) ls_ret_20 = ls_ret_20 + "The bottom minimum is generated : ";
   ls_ret_20 = ls_ret_20 + TimeToString(ai_16, TIME_DATE) + " " + TimeToString(ai_16, TIME_MINUTES) + " Price Value: ";
   ls_ret_20 = ls_ret_20 + DoubleToString(ad_8, _Digits+y);
   return (ls_ret_20);
}

bool ObjectSetText(string name,
                       string text,
                       int font_size,
                       string font="",
                       color text_color=CLR_NONE)
  {
   int tmpObjType=(int)ObjectGetInteger(0,name,OBJPROP_TYPE);
   if(tmpObjType!=OBJ_LABEL && tmpObjType!=OBJ_TEXT) return(false);
   if(StringLen(text)>0 && font_size>0)
     {
      if(ObjectSetString(0,name,OBJPROP_TEXT,text)==true
         && ObjectSetInteger(0,name,OBJPROP_FONTSIZE,font_size)==true)
        {
         if((StringLen(font)>0)
            && ObjectSetString(0,name,OBJPROP_FONT,font)==false)
            return(false);
         if(ObjectSetInteger(0,name,OBJPROP_COLOR,text_color)==false)
            return(false);
         return(true);
        }
      return(false);
     }
   return(false);
  }
  
void CheckLab() {
   if (ObjectFind(0,gs_durko_l1_312) == -1) {ResetLastError();CreateLab(gs_durko_l1_312);}
   if (ObjectFind(0,gs_durko_l2_320) == -1) {ResetLastError();CreateLab(gs_durko_l2_320);}
   ObjectSetText(gs_durko_l1_312, "Waves Auto Trend Indicator - Durko Ltd", 10, "Arial", SaddleBrown);
   ObjectSetText(gs_durko_l2_320, "umnyak@inbox.ru", 12, "Arial", SaddleBrown);
}


void CreateLab(string as_0) {
   datetime Time[];
   ArraySetAsSeries(Time,true);
   CopyTime(_Symbol,_Period,0,1+1,Time);
   double High[];
   ArraySetAsSeries(High,true);
   CopyHigh(_Symbol,_Period,0,1+1,High);
   if (as_0 == gs_durko_l1_312) {
      ObjectCreate(0,gs_durko_l1_312, OBJ_LABEL, 0, Time[1], High[1]);
   //if(gs_durko_l1_312=="LTL_Asys_AutoTL_1440_Res - 137")Alert(333);
      ObjectSetInteger(0,gs_durko_l1_312,OBJPROP_CORNER,0);
      ObjectSetInteger(0,gs_durko_l1_312,OBJPROP_XDISTANCE,225);
      ObjectSetInteger(0,gs_durko_l1_312,OBJPROP_YDISTANCE,8);
      ObjectSetText(gs_durko_l1_312, "Waves Auto Trend Indicator - Durko Ltd", 10, "Arial", SaddleBrown);
   }
   if (as_0 == gs_durko_l2_320) {
      ObjectCreate(0,gs_durko_l2_320, OBJ_LABEL, 0, Time[1], High[1]);
   //if(gs_durko_l1_312=="LTL_Asys_AutoTL_1440_Res - 137")Alert(444);
      ObjectSetInteger(0,gs_durko_l2_320,OBJPROP_CORNER,0);
      ObjectSetInteger(0,gs_durko_l2_320,OBJPROP_XDISTANCE,645);
      ObjectSetInteger(0,gs_durko_l2_320,OBJPROP_YDISTANCE,7);
      ObjectSetText(gs_durko_l2_320, "Durko Ltd", 12, "Arial", SaddleBrown);
   }
}